<?php
	
/********************************************************************************
* June 12/2002: Blaine Lang                                                     *
* Modified to work with Geeklog - structured as functions                       *
* and building HTML output to be called as a phpblock and                       *
*                                                                               *
* Sept 2/02: Fixed a bug where today was not being higlighted in the next month *
* Changed all occurances of $InThisMonth to $GLOBALS['InThisMonth']             *
*                                                                               *
* Sept 15/02: Version 2.0                                                       *
* ALmost a complete re-write, code restructured                                 *
* Integrated vesion with Site Search and Events Calendar                        *
* Displayed dates are now active hyperlinks to search results for that day      *
* Added ability to view next/prev months                                        *
* Now using Template classes for fonts                                          *
* Fixed bug with extra week showing up occasionally                             *
*                                                                               *
* Sept 16/02: Fixed bug where I was not checking access to events that were     *
* displayed on the calendar - added access checks.                              *
* Note: Currently only checking system calendar for events  - not personal      *
*                                                                               *
* Nov 18/02: Last months dates that were showing up at the beginning of the     *
* calendar display, were linking as next months dates.                          *
*                                                                               *
*********************************************************************************/


function display_calendar() {
    global $HTTP_POST_VARS,$_TABLES,$_CONF;
	
	if( !isset($HTTP_POST_VARS['month']) ) {
		$WorkDate = date("m/d/Y");
	}
	else{
		$WorkDate = $HTTP_POST_VARS['month'];
		$GLOBALS['WorkDate'] = $WorkDate;
	}
	$PrevMonth = date("m/d/Y", strtotime($WorkDate . "-1 month"));
	$NextMonth = date("m/d/Y", strtotime($WorkDate . "+1 month"));
	$Today = date("j",strtotime($WorkDate));
	$DaysThisMonth = DaysInMonth(date("m/d/Y",strtotime($WorkDate)));
	$DaysLastMonth = DaysInMonth(date("m/d/Y", strtotime ($PrevMonth)));
	
	$GLOBALS['InThisMonth'] = 0;
	$CurrentDate = GetStartingPoint($DaysLastMonth);

	//Head
	$BlockDisplay = "<html><head></head>";

	//Header with Month Title and Next/Prev buttons
	$loc = $PHP_SELF . '?';
	$BlockDisplay .= "<body topmargin='0' leftmargin='0' marginheight='0' marginwidth='0'>";
	$BlockDisplay .= "<table class='mycalTitle' height='100%' width='100%' border='1'><tr>";
	$BlockDisplay .= "<td colspan='7' height='8%' align='center' >";
	$BlockDisplay .= "<table height='100%' width='100%' border='0'><tr>";
    
	$BlockDisplay .= "<td class='mycalTitle' align='center'>";
	$BlockDisplay .= "<font size='2'><b>".date("F Y",strtotime($WorkDate))."</b></font></td>";
	
	$BlockDisplay .= "</table>"; 
    // Main Calendar
	$BlockDisplay .= "</td></tr>";
	$BlockDisplay .= "<td height='8%' align='center' valign='top' width='15%' class='mycalTitle'><font size='1'><b>Su</b></font></td>";
	$BlockDisplay .= "<td align='center' valign='top' width='14%' class='mycalTitle'><font size='1'><b>Mo</b></font></td>";
	$BlockDisplay .= "<td align='center' valign='top' width='14%' class='mycalTitle'><font size='1'><b>Tu</b></font></td>";
	$BlockDisplay .= "<td align='center' valign='top' width='14%' class='mycalTitle'><font size='1'><b>We</b></font></td>";
	$BlockDisplay .= "<td align='center' valign='top' width='14%' class='mycalTitle'><font size='1'><b>Th</b></font></td>";
	$BlockDisplay .= "<td align='center' valign='top' width='14%' class='mycalTitle'><font size='1'><b>Fr</b></font></td>";
	$BlockDisplay .= "<td align='center' valign='top' width='15%' class='mycalTitle''><font size='1'><b>Sa</b></font></td></tr>";
	
	for($x=1;$x<7;$x++){
		$BlockDisplay .= "<tr>";
		for($i=1;$i<8;$i++){
			$BlockDisplay .= "<td align='left' valign='top' height='14%' ";

			if($GLOBALS['InThisMonth']==0){
				// If this date is not the present month then we need to check for if this at
				// the top of the calendar display - last months date or at the bottom - next months date
				// Easist way is to check the date - can't be more the 7 days in either row.
				if ($CurrentDate > 23 ) {
				    $eventurl = mycal_eventurl($WorkDate,$CurrentDate,'-1');
				} else {
					$eventurl = mycal_eventurl($WorkDate,$CurrentDate,'1');
				}	
				$BlockDisplay .= $eventurl;
				$CurrentDate++;
						    
			} else {
			    
				if( $CurrentDate == date("j") && date("n",strtotime($WorkDate)) == date("n") && date("y",strtotime($WorkDate)) == date("y") ){
					$eventurl = mycal_eventurl($WorkDate,$CurrentDate,'0');
					$BlockDisplay .= $eventurl;
					$CurrentDate++;
               	} else {
					$eventurl = mycal_eventurl($WorkDate,$CurrentDate,0);
					$BlockDisplay .= $eventurl;
					$CurrentDate++;
                }
			}

			$BlockDisplay .= "</center></td>";

			if( $GLOBALS['InThisMonth'] == 0 && $CurrentDate > $DaysLastMonth ){
				$CurrentDate = 1;
				$GLOBALS['InThisMonth'] = 1;
			}
			elseif($GLOBALS['InThisMonth'] == 1 && $CurrentDate > $DaysThisMonth ){
				$CurrentDate = 1;
				$GLOBALS['InThisMonth'] = 0;
			}

		}

		$BlockDisplay .= "</tr>";
		// Check to see if I need to display another week
		if ($GLOBALS['InThisMonth']==0) {
			break;
		}
		
	}

	$BlockDisplay .= "</table>";
	$BlockDisplay .= "<table height='100%' width='100%' border='0'><tr>";
	$BlockDisplay .= "<td>";	
	$BlockDisplay .= "<form method='post' action='$loc' >";
    $BlockDisplay .= "<input type='submit' value='<'>";
    $BlockDisplay .= "<input type='hidden' name='month' value='$PrevMonth'>";
    $BlockDisplay .= "</form></td>";
	$BlockDisplay .= "<td align='center'><font size='-2'>"._mycal_ClickonDate."</font></td>";
	$BlockDisplay .= "<td>";	
	$BlockDisplay .= "<form align='right' method='post' action='$loc' >";
    $BlockDisplay .= "<input type='submit' value='>'>";
    $BlockDisplay .= "<input type='hidden' name='month' value='$NextMonth'>";
    $BlockDisplay .= "</form></td>";
	$BlockDisplay .= "</table>";

	$BlockDisplay .= "</body></html>";
	return $BlockDisplay;

}
	function DaysInMonth($dt) {
		return date("t",strtotime($dt));
	}

	function GetStartingPoint($DLM){
	global $InthisMonth;
		$today = getdate(strtotime($GLOBALS['WorkDate']));
		$mday = $today['mday'];
		$mday-=1;
		$FirstOfMonth = date("m/d/Y",strtotime($GLOBALS['WorkDate'] . "-" . $mday . " days"));

		// Determine which day of the week the first day of this month starts on
		switch(date("l",strtotime($FirstOfMonth))){
		case "Sunday":
			$CD = 1;
			$GLOBALS['InThisMonth'] = 1;
			break;

		case "Monday":
			$CD = $DLM;
			break;

		case "Tuesday":
			$CD = $DLM-1;
			break;

		case "Wednesday":
			$CD = $DLM-2;
			break;

		case "Thursday":
			$CD = $DLM-3;
			break;

		case "Friday":
			$CD = $DLM-4;
			break;

		case "Saturday":
			$CD = $DLM-5;
		}

		return $CD;
	}

	function GetThisDate($SelectedDay){
		$today = getdate(strtotime($GLOBALS['WorkDate']));
		$mon = $today['mon'];
		$myear = $today['year'];
		return date("m/d/Y", strtotime($mon."/".$SelectedDay."/".$myear));
	}
	
	// support date format as : 23 1 2003, 23-01-2003, 23/01/2003, 
	// return timestamp
	function mycal_eventurl($WorkDate,$CurrentDate,$monthchk='0'){
	    global $_TABLES,$_CONF;

	    $HighlightToday = false;
		$eventchk_date = "20". date("y",strtotime($WorkDate)) ."-".(date("n",strtotime($WorkDate))+$monthchk) ."-". $CurrentDate;
		if( $CurrentDate == date("j") && date("n",strtotime($WorkDate)) == date("n") && date("y",strtotime($WorkDate)) == date("y") ){
		    $HighlightToday = true;
		}
		$eventSql = "SELECT eid, title,url,datestart,dateend,group_id,owner_id,perm_owner,perm_group,perm_members,perm_anon  FROM {$_TABLES['events']} WHERE datestart = '$eventchk_date'";
		$result = DB_query($eventSql);
		$eventday = $CurrentDate++;
		$theEvent= DB_fetchArray($result);

		if ((DB_numrows($result) > 0) && 
		    (SEC_hasAccess($theEvent['owner_id'],$theEvent['group_id'],$theEvent['perm_owner'],$theEvent['perm_group'],$theEvent['perm_members'],$theEvent['perm_anon']) > 0)) {
				$event_title = $theEvent['title'];
				$eventmonth = date("n",strtotime($WorkDate))+$monthchk;
				if ($HighlightToday){
					$event_url = 'class="mycalTodayHighlight">';
				} else {
				    $event_url = 'class="mycalEventHighlight">';
				}
				$event_url .= '<center><a href="' .$_CONF["site_url"] .'/search.php?mode=mycal&date=' . 
				$eventchk_date.'" TITLE="'.$event_title.'"><b>'.$eventday.'</b></a>';
				return $event_url;	
		} else {
		    if ($monthchk < 0) {
				$event_url = 'class="mycalNextMonth"><center><a href="' .$_CONF["site_url"] .'/search.php?mode=mycal&date=' . $eventchk_date.'">'.$eventday.'</a>';
			} else {
				if ($HighlightToday){
				    $event_url = 'class="mycalTodayHighlight">';

				} else {
				    $event_url = 'class="mycalDateField">';
				}
				$event_url .='<center><a href="' .$_CONF["site_url"] .'/search.php?mode=mycal&date=' . $eventchk_date.'"><b>'.$eventday.'</b></a>';
			}
			return $event_url;
		}
	}

?>